rm -rf _out
mkdir _out
find . -type d -not -name '*.html.inc' -not -name '_out' -not -name '.' -not -name '.git' -not -path './.git/*' -print |
while read file; do
	mkdir -v "_out/$file"
done

find . -not -type d -not -iname '*.jpg' -not -iname '*.jpeg' -not -name '*.html' -not -name '*.html.toc' -not -name '*.html.inc' -not -path './.git/*' -not -name '.gitignore' -print |
while read file; do
	cp -v "$file" "_out/$file"
done

find . -not -type d -iname '*.jpeg' -print |
while read file; do
	echo stripping "$file" '>' "_out/$file"
	jpegtran -copy none "$file" > "_out/$file"
done

find . -not -type d -iname '*.jpg' -print |
while read file; do
	echo stripping "$file" '>' "_out/$file"
	jpegtran -copy none "$file" > "_out/$file"
done

find . -not -type d -name '*.html' -print |
while read file; do
	{ 
	echo '<div id="rightbox">'
	cat "$file" | grep 'h[12] id' | sed 's|<h2 *id=\([^>]*\)>\([^<]*\)</h2>|<li><a href="#\1">\2</a></li>|g' | sed 's|<h1 *id=\([^>]*\)>\([^<]*\)</h1>|</ul>\n<h1>\2</h1>\n<ul>|g'1 | tail -n +2
	echo "</ul>"
	echo '</div>'; } > "$file.toc"
	
	echo processing "$file" '>' "_out/$file"
	cat "$file" | sed "s/'/\&apos;/g" | gcc -traditional-cpp -I$(dirname "$file") -E -x c -P -C  - | sed 's/ WEBSITE_HACK_QUOTES /"/g' > "_out/$file"
done

rm _out/make.sh
