#include "fbgfx.bi"

#define conswrite(foo) open cons for output as #198: ?#198,foo:close #198
#define rndrange(a,b) (rnd*((b)-(a))+(a))


' +++++++ CONFIGURATION SECTION +++++++ '
const smooth=40   ' how much so smoothen the lines
const speed=2     ' how fast the lines are oscillating
const range=4     ' what's the limit of the lines' oscillation

const xstep=64    ' determines the size of the bricks
const ystep=16*2

const xres=1024   ' screen (and output) resolution
const yres=768
'++++++++++++++++++++++++++++++++++++++ '

const n_x=int(xres/xstep)+1
const n_y=int(yres/ystep)+1
const yoffset=-ystep/2

declare sub vert_line (y as integer, x as integer, offset as integer)

function fixrange(a as integer, b as integer, x as integer) as integer
  if a>b then swap a,b
  if x<a then x=a else if x>b then x=b
  return x
end function

sub fading_circle (array() as integer, mx as integer, my as integer, r as integer, col as integer, al as integer)
  dim as integer x,y,r2
  dim as single d,a
  r2=r*r
  for x=-r to r
    for y=-r to r
      if x+mx>=lbound(array,1) and x+mx<=ubound(array,1) and y+my>=lbound(array,2) and y+my<=ubound(array,2) then
        d=x*x+y*y
        if d>r2 then a=0 else a= (1-d/r2)*al
        array(x+mx, y+my)= (a*col + (256-a)*array(x+mx, y+my)) / 256
      end if
    next
  next
end sub


sub gen_brick(brick2() as integer)
  dim as integer col,x,y,col2

  dim as integer brick1(-range to xstep+range-1, -range to ystep+range-1)
  'dim as integer brick2(-range to xstep+range-1, -range to ystep+range-1)
  dim as integer brick3(-range to xstep+range-1, -range to ystep+range-1)

  col=rndrange(128,196)

  'fading_circle (brick3(), xstep/2, ystep/2, xstep, 255, 255)
  dim as integer r
  for i as integer=1 to 200
    r=rndrange(xstep,xstep) '(xstep/2,xstep/2)
    fading_circle (brick3(), rndrange(-range-r,xstep+range-1+r) , rndrange(-range-r,ystep+range-1+r), r , rndrange(64,196), rndrange(196,255))
  next


  dim as single ymin, xmax
  dim as single a
  dim as single dark
  'dim as single m,t

  ymin=0.5'0.33
  xmax=range+10
  a=(1-ymin)/xmax/xmax
  for x=0 to xmax
    dark=1-a*(x-xmax)^2
    for y=-range to ystep+range-1
      brick3(-range+x,y)*=dark
      brick3(range+xstep-1-x,y)*=dark
    next
  next

  ymin=0.5'0.33
  xmax=range+5
  a=(1-ymin)/xmax/xmax
  for y=0 to range+5
    dark=1-a*(y-xmax)^2
    for x=-range to xstep+range-1
      brick3(x,-range+y)*=dark
      brick3(x,range+ystep-1-y)*=dark
    next
  next



  for x=0-range to xstep+range-1
    for y=-range to ystep+range-1
      brick1(x,y)=rndrange(-10,10)+brick3(x,y)
    next
  next

  for x=-range to xstep+range-1
    for y=-range to ystep+range-1
      brick2(x,y)=( brick1( fixrange(-range,xstep+range-1 ,x  ), fixrange(-range,ystep+range-1, y  ) ) + _
                    brick1( fixrange(-range,xstep+range-1 ,x+1), fixrange(-range,ystep+range-1, y  ) ) + _
                    brick1( fixrange(-range,xstep+range-1 ,x  ), fixrange(-range,ystep+range-1, y+1) ) + _
                    brick1( fixrange(-range,xstep+range-1 ,x+1), fixrange(-range,ystep+range-1, y+1) ) ) / 4
    next
  next
end sub





screenres xres,yres,32 ,,fb.gfx_alpha_primitives 

dim as single x

/'for i as integer = 0 to 767
  x+=rndrange(-1,1)
  if x<-range then x=-range else if x>range then x=range
  pset (x+500,i),rgb(255,255,255)
next'/

dim as single z(0 to xres-1+smooth-1) '<- temp. feld als puffer
dim as single z2(0 to n_y, 0 to xres-1) ' <-- die horizontalen linien
        '         ^zeile n hat z_n
        '        als obere begrenzung
for foo as integer=0 to xres-1
  z2(n_y,foo)=yres
next

'dim as single s(-range to ystep-range+smooth-1) '<- temp. feld als puffer
dim shared as single s2(0 to n_y-1,-1 to n_x-1, -range to ystep+range)
              '        ^zeile       ^nummer von links
              '      (beginn bei  (block n hat s_n als
              '     dieser zeile) rechte begrenzung)
              
for foo as integer=0 to n_y-1
  for bar as integer=-range to ystep-range
    s2(foo,-1,bar)=0
  next
next

dim as integer s_offset(0 to n_y)


dim as integer brick2(-range to xstep+range-1, -range to ystep+range-1)

'Umrisse Generieren:
' o die horiz. zeilen generieren (z muss klartext enthalten, nicht verschiebung wie atm!)
' o die vertikalen spalten mit offset und overhead generieren (s muss klartext enthalten!)

'Steine generieren:
' x imagebuffer mit overhead erzeugen
' x wahllos verschieden graue und dicke punkte einzeichnen
' x weichzeichnen

'Steine zeichnen:
' o durch alle x- und y-e durchiterieren:
' o wenn x und y im zeichenbaren bereich liegen:
' o wenn y im bereich der zeilen liegt
' o und x im bereich der spalten liegt
' o vom buffer auf den screen malen

'Umrisse zeichnen:
' o die zeilen zeichnen
' o die spalten durchiterieren, wenn y zwischen den begrenzenden zeilen liegt, zeichnen!


dim as integer x0,x0alt
dim as integer CW,CCW


for y as integer=0 to n_y-1    'generate the horiz. lines
  z(0)=rndrange(-range,range)
  for i as integer = 0+1 to xres-1+smooth-1
    z(i)=z(i-1)+rndrange(-speed,speed)
    if z(i)<-range then z(i)=-range else if z(i)>range then z(i)=range
  next
  
  for i as integer= 0 to xres-1 'smoothen them
    z2(y,i)=0
    for j as integer=i to i+smooth-1
      z2(y,i)+=z(j)
    next
    z2(y,i)=z2(y,i)/smooth  +  y*ystep+yoffset
  next
  
  '---------------------------------------------------------------------
  
  do
    x0=rndrange(0,xstep-1)
    CW=x0-x0alt
    CCW=xstep-CW
    'foo=(x0alt-x0)
  loop while abs(CW)<16 or abs(CCW)<16  'abs(x0-x0alt)<32
  x0alt=x0
  
  for x as integer=0 to n_x-1
    vert_line(y,x,x0)
    s_offset(y)=x0
  next
  
  
  
  
  for x as integer=0 to xres-1
    pset(x,z2(y,x)),rgb(255,255,255)
  next
  
  for x as integer=0 to n_x-1
    for yy as integer=-range to ystep+range-1
      pset(s2(y,x,yy),y*ystep+yoffset+yy),rgb(255,255,0)
      pset(s_offset(y),y*ystep+yoffset+yy),rgb(127,127,255)
    next
  next
next


'const fillx=2
'const filly=2
'gen_brick(brick2())

for fillx as integer=0 -1 to n_x-1 -1
for filly as integer=0 to n_y-1
'conswrite ("gen... ";)
gen_brick(brick2())
'conswrite ("done")
for x as integer=fillx*xstep+s_offset(filly)-range to fillx*xstep+s_offset(filly)+xstep+range+1
  for y as integer=filly*ystep+yoffset-range to filly*ystep+yoffset+range-1+ystep
    'pset(x,y),rgba(255,255,255,64)
    if x>=0 and x<xres and y>=0 and y<yres then
      if  x>=s2(filly,fillx,y-filly*ystep-yoffset)    and _   'fillx wird -1 bei s2. an fillx=-1 muss s2<=x -> s2<=0 -> s2=0!
          x<=s2(filly,fillx+1,y-filly*ystep-yoffset)  and _   
          y>=z2(filly,x)                              and _   
          y<=z2(filly+1,x)                            then    'filly wird n_y bei z2. an filly?n_y muss z2>=y -> z2>=yres -> z2=yres
        pset (x,y),rgb(brick2(x-fillx*xstep-s_offset(filly),y-yoffset-filly*ystep),brick2(x-fillx*xstep-s_offset(filly),y-yoffset-filly*ystep),brick2(x-fillx*xstep-s_offset(filly),y-yoffset-filly*ystep))
      end if
    end if
  next
next

next
next

dim as uinteger c
for y as integer=0 to n_y-1
  dim as integer zi
  dim as single zs
  dim as integer last,col,al
  for i as integer=0 to xres-1
    zi=int(z2(y,i))
    zs=z2(y,i)-zi
    
    last=0
    for j as integer=-2 to 2 +1
      'col=iif(abs(j)<=2,255-abs(j)*64,0)
      select case abs(j)
        case 0: col=127
        case 1: col=64
        case 2: col=32
        case else: col=0
      end select
      
      al=(1-zs)*col + zs*last
      
      pset(i,zi+j),rgba(64,64,64,al)
      
      last=col
    next
  next

  
  for x as integer=0 to n_x-1
    for i as integer=-range to ystep+range-1
      if s2(y,x,i)>=0 and s2(y,x,i)<xres then
        if y*ystep+yoffset+i>=z2(y,int(s2(y,x,i))) and y*ystep+yoffset+i<=z2(y+1,int(s2(y,x,i))) then
          zi=int(s2(y,x,i))
          zs=s2(y,x,i)-zi
          
          last=0
          for j as integer=-2 to 2 +1
            select case abs(j)
              case 0: col=127
              case 1: col=64
              case 2: col=32
              case else: col=0
            end select

            al=(1-zs)*col + zs*last

            pset(zi+j,y*ystep+yoffset+i),rgba(64,64,64,al)      
            
            last=col
          next
        end if
      end if
    next
  next
next

sleep
end



for y as integer=0 to 768-ystep step ystep
  do
    x0=rndrange(0,xstep-1)
    CW=x0-x0alt
    CCW=xstep-CW
    'foo=(x0alt-x0)
  loop while abs(CW)<16 or abs(CCW)<16  'abs(x0-x0alt)<32
  x0alt=x0
  
  for x as integer=x0 to 1023 step xstep
    'line (x, z2(y/ystep,x)+y)-(x,z2(y/ystep+1,x)+y+ystep),rgb(255,255,255) 'rgb(y*255/768,x*255/1024,0)
    vert_line(x,z2(y/ystep,x)+y,z2(y/ystep+1,x)+y+ystep)
    
    if y=4*ystep and x=4*xstep+x0 then
      dim as integer xx,yy
      for xx=x-xstep-range to x+range
        for yy=y-range to y+range+ystep
          pset (xx,yy),rgb(64,64,64)
        next
      next
    end if
  next
next








for y as integer=0 to 768 step ystep
  
  
  z(0)=rndrange(-range,range)
  for i as integer = 0+1 to 1023+smooth-1
    z(i)=z(i-1)+rndrange(-speed,speed)
    if z(i)<-range then z(i)=-range else if z(i)>range then z(i)=range
  next
  
  for i as integer= 0 to 1023
    z2(y/ystep,i)=0
    for j as integer=i to i+smooth-1
      z2(y/ystep,i)+=z(j)
    next
    z2(y/ystep,i)/=smooth
  next

  dim as integer zi
  dim as single zs
  dim as integer last,col,al
  for i as integer=0 to 1023
    zi=int(z2(y/ystep,i))
    zs=z2(y/ystep,i)-zi
    
    last=0
    for j as integer=-2 to 2 +1
      col=iif(abs(j)<=2,255-abs(j)*64,0)
      
      al=(1-zs)*col + zs*last
      
      pset(i,zi+y+j),rgba(255,255,255,al)
      
      last=col
    next
  next
/'  for i as integer=0 to 1023
    pset (i,z2(y/ystep,i)+y),rgba(255,255,255,255)
    pset (i,z2(y/ystep,i)+y+1),rgba(255,255,255,196)
    pset (i,z2(y/ystep,i)+y-1),rgba(255,255,255,196)
    pset (i,z2(y/ystep,i)+y+2),rgba(255,255,255,127)
    pset (i,z2(y/ystep,i)+y-2),rgba(255,255,255,127)
  next'/
next

'dim as integer x0,x0alt
'dim as integer CW,CCW
for y as integer=0 to 768-ystep step ystep
  do
    x0=rndrange(0,xstep-1)
    CW=x0-x0alt
    CCW=xstep-CW
    'foo=(x0alt-x0)
  loop while abs(CW)<16 or abs(CCW)<16  'abs(x0-x0alt)<32
  x0alt=x0
  
  for x as integer=x0 to 1023 step xstep
    'line (x, z2(y/ystep,x)+y)-(x,z2(y/ystep+1,x)+y+ystep),rgb(255,255,255) 'rgb(y*255/768,x*255/1024,0)
    vert_line(x,z2(y/ystep,x)+y,z2(y/ystep+1,x)+y+ystep)
    
    if y=4*ystep and x=4*xstep+x0 then
      dim as integer xx,yy
      for xx=x-xstep-range to x+range
        for yy=y-range to y+range+ystep
          pset (xx,yy),rgb(64,64,64)
        next
      next
    end if
  next
next


sleep



sub vert_line (y as integer, x as integer, offset as integer)
  dim as single z(-range to ystep+range-1+smooth-1)
  conswrite (y;" ";x)
  z(-range)=rndrange(-range,range)
  for i as integer = -range+1 to ystep+range-1+smooth-1
    z(i)=z(i-1)+rndrange(-speed,speed)
    if z(i)<-range then z(i)=-range else if z(i)>range then z(i)=range
  next
  
  for i as integer=-range to ystep+range-1
    s2(y,x,i)=0
    for j as integer=i to i+smooth-1
      s2(y,x,i)+=z(j)
    next
    s2(y,x,i)=s2(y,x,i)/smooth  +  xstep*x + offset
  next
  
/'  dim as integer zi
  dim as single zs
  dim as integer last,col,al
  for i as integer=y1 to y2
    zi=int(z2(i))
    zs=z2(i)-zi
    
    last=0
    for j as integer=-2 to 2 +1
      col=iif(abs(j)<=2,255-abs(j)*64,0)
      
      al=(1-zs)*col + zs*last
      
      pset(zi+x+j,i),rgba(255,255,255,al)
      
      last=col
    next
  '/  
/'    pset (z2(i)+x,i),rgba(255,255,255,255)
    pset (z2(i)+x-1,i),rgba(255,255,255,196)
    pset (z2(i)+x+1,i),rgba(255,255,255,196)
    pset (z2(i)+x-2,i),rgba(255,255,255,127)
    pset (z2(i)+x+2,i),rgba(255,255,255,127)'/
 ' next
end sub

sub horiz_line (y as integer, x1 as integer, x2 as integer)
  dim as single z(x1 to x2+smooth-1)
  dim as single z2(x1 to x2)
  
  
  z(x1)=rndrange(-range,range)
  for i as integer = x1+1 to x2+smooth-1
    z(i)=z(i-1)+rndrange(-speed,speed)
    if z(i)<-range then z(i)=-range else if z(i)>range then z(i)=range
  next
  
  for i as integer= x1 to x2
    z2(i)=0
    for j as integer=i to i+smooth-1
      z2(i)+=z(j)
    next
    z2(i)/=smooth
  next

  
  for i as integer=x1 to x2
    pset (i,z2(i)+y),rgb(255,255,255)
  next
end sub
